InnerException Свойство
Данная статья переведена автоматически. Наведите указатель мыши на предложения статьи, чтобы просмотреть исходный текст. Дополнительные сведения.
Текст оригинала

Свойство Exception.InnerException


Возвращает экземпляр класса Exception, который вызвал текущее исключение.

Пространство имен:   System
Сборка:  mscorlib (в mscorlib.dll)

public Exception InnerException { get; }

Значение свойства

Type: System.Exception

Объект, описывающий ошибку, которая вызвала текущее исключение. Свойство InnerException возвращает то же значение, что было передано в конструктор Exception(String, Exception), или значение null, если конструктору не было передано значение внутреннего исключения. Это свойство доступно только для чтения.



When an exception X is thrown as a direct result of a previous exception Y, the P:System.Exception.InnerException property of X should contain a reference to Y.

Use the P:System.Exception.InnerException property to obtain the set of exceptions that led to the current exception.

You can create a new exception that catches an earlier exception. The code that handles the second exception can make use of the additional information from the earlier exception to handle the error more appropriately.

Suppose that there is a function that reads a file and formats the data from that file. In this example, as the code tries to read the file, an T:System.IO.IOException is thrown. The function catches the T:System.IO.IOException and throws a T:System.IO.FileNotFoundException. The T:System.IO.IOException could be saved in the P:System.Exception.InnerException property of the T:System.IO.FileNotFoundException, enabling the code that catches the T:System.IO.FileNotFoundException to examine the cause of the initial error.

The P:System.Exception.InnerException property, which holds a reference to the inner exception, is set upon initialization of the exception object.

The following example demonstrates throwing and catching an exception that references an inner exception.

using System;

public class AppException : Exception
   public AppException(String message) : base (message)

   public AppException(String message, Exception inner) : base(message,inner) {}

public class Example
   public static void Main()
      Example ex = new Example();

      try {
      catch(AppException e) {
         Console.WriteLine ("In catch block of Main method.");
         Console.WriteLine("Caught: {0}", e.Message);
         if (e.InnerException != null)
            Console.WriteLine("Inner exception: {0}", e.InnerException);

   public void ThrowInner ()
      throw new AppException("Exception in ThrowInner method.");

   public void CatchInner() 
      try {
      catch (AppException e) {
         throw new AppException("Error in CatchInner caused by calling the ThrowInner method.", e);
// The example displays the following output:
//    In catch block of Main method.
//    Caught: Error in CatchInner caused by calling the ThrowInner method.
//    Inner exception: AppException: Exception in ThrowInner method.
//       at Example.CatchInner()

Universal Windows Platform
Доступно с 4.5
.NET Framework
Доступно с 1.1
Portable Class Library
Поддерживается в версиях: portable .NET platforms
Доступно с 2.0
Windows Phone Silverlight
Доступно с 7.0
Windows Phone
Доступно с 8.1
Вернуться в начало
© 2015 Microsoft